
;  MCU target		ATtiny2313
;  MCU freq		4 MHz
;  RC protocol		NEC 
#include	"tn2313def.inc"
; ---   ---
.def	Nomer		= R16				  
.def	C		= R17		    	;   
.def	Delay		= R18			;  
.def    temp   =   R19              ;  
.def	Command_0	= R20;			;    
.def	Command_1	= R21;
.def	Command_2	= R22;
.def	Command_3	= R23;

; ---   ---             
.equ    Delay_1125us =$B6 ;f=4.0 MHz:TCCR0B=11 8  ($b6+73=$ff)  .
                             ;     1.125/ 
						     ;  1.19-1.20 /,AVRCalk.
; ---   ---
.equ	IRR		= 3		;PD3 -  
.equ    SINXRO  = 5     ;PD5 - -  .

;==========================================================================
        .cseg
;---    ---
        .org 0
        rjmp RESET		;  
   	    reti   ;INT0  External Interrupt0 Handler
	    reti   ;INT1 ; External Interrupt1 Handler
	    reti   ;rjmp TIM1_CAPT ; Timer1 Capture Handler
 	    reti   ;rjmp TIM1_COMPA ; Timer1 CompareA Handler
 	    reti   ;rjmp TIM1_OVF ; Timer1 Overflow Handler
 	    rjmp TIM0_OVF ; Timer0 Overflow Handler
 	    reti   ;USART0_RXC ; USART0 RX Complete Handler
   	    reti   ;rjmp USART0_DRE ; USART0,UDR Empty Handler
 	    reti   ;rjmp USART0_TXC ; USART0 TX Complete Handler
 	    reti   ;rjmp ANA_COMP ; Analog Comparator Handler
 	    reti   ;rjmp PCINT ; Pin Change Interrupt
 	    reti   ;rjmp TIMER1_COMPB ; Timer1 Compare B Handler
 	    reti   ;rjmp TIMER0_COMPA ; Timer0 Compare A Handler
 	    reti   ;rjmp TIMER0_COMPB ; Timer0 Compare B Handler
 	    reti   ;rjmp USI_START ; USI Start Handler
	    reti   ;rjmp USI_OVERFLOW ; USI Overflow Handler
	    reti   ;rjmp EE_READY ; EEPROM Ready Handler
 	    reti   ;rjmp WDT_OVERFLOW ; Watchdog Overflow Handler
;======================

; ---  ---
RESET:
     	cli					; 
		ldi	temp,$DF
        out	SPL,temp	     ;  

		ldi	temp,0b11111111  
 	    out	DDRB,temp       ;  PortB (1)- 
    	
		ldi	temp,0b1110111  ;PD3-TSOP 1736 .PD5-SINXRO
 	    out	DDRD,temp       ;  PortD (1)-  PD0,PD1,PD2,PD4,PD5,PD6.
		
		ldi	temp,0b0000000  ;    D.  
		out	PORTD,temp      

        ldi temp ,(1<<ACD)	; 
        out ACSR,temp 		
			
		rcall	Reset_TMR	; 
	
		sei					;  

					     	
Main:	sbi	PortD,	SINXRO  ;  ! 

   
        clr Nomer		    ;      
				            ;   Command_0.
	    clr	Command_0	    ;   
	    clr	Command_1 
	    clr	Command_2
	    clr	Command_3

Main_0: sbic	PinD,	IRR	; 0 (    )
		rjmp   Main_0
                
        ldi	Delay,	8		; 8   (8 * 1,125 = 9 )
        rcall	Resync_TMR	; 

Main_1: tst	Delay			;   
	    breq	Main		;  ,  

        sbis	PinD,	IRR	;  1 - 
        rjmp	Main_1

        cpi	Delay,	2	     ;  ,   1 - 
        brge	Main
	    cbi	PortD,	SINXRO  ;    !
        ldi	Delay,	4		; 4   (4 * 1,125 = 4,5 )
        rcall	Resync_TMR	; 

Main_2:	tst	Delay			;   
		breq	Main		;  ,  
        sbic	PinD,	IRR	;  0 - 
        rjmp	Main_2

        cpi	Delay,	2		;  ,   1 - 
        brge	Main

; *** Loop ***				
		ldi	C,	32          ;   -  32 	
						
Loop_1: sbic PinD,IRR       ;  0.  
  		rjmp LooP_1	 

        ldi	Delay,	1		; 1   (1,125 )
        rcall	Resync_TMR	; 

Main_3:	tst	Delay			; 1
        breq	Main		;   1  ( ) -  
        sbis	PinD,	IRR	;  1 - 
        rjmp	Main_3

 Main_4:tst	Delay			; 0
		breq	Main_S1		; 1  (1,125 ) -> "1"
        sbic	PinD,	IRR	; 1  (1,125 ) -> "0"
        rjmp	Main_4

Main_S0:clc					; "0"   
        rjmp	Main_SB
Main_S1:sec					; "1"   

Main_SB:rol	Command_0		;    
       	rol	Command_1		;   
       	rol	Command_2
       	rol	Command_3

		dec	C				; 
        brne	Loop_1		; 
;************  ***************************************************************
;      NEC      
;  , ( Command_3)
; ,  ( Command_2 )   . -  ,
;-  .
;         (0x40,0xBF) ,
;    (0x40,0xBF,0x00,0xFF) ..    ()
;  (  ).
;            
; -    Command_3  Command_2.
;      .

 
	LDI 	ZL,low(one*2)	;     . 
	LDI 	ZH,high(one*2)	;..  ,    2    .
	LPM		temp,Z+		    ;   one,   Z
		                    ;c    1 .
	CP		Command_3,temp  ;        one
				            ; "0x40"(  )
	BRNE    Main            ;    .
	LPM		temp,Z+		    ;   one,  
		                    ;c    1
	CP		Command_2,temp  ;        one
				            ; "0xBF"(  )
	BRNE    Main            ;    .
		 
;*********   *************                           	
;      Nachalo2  Command_0       mesg
;       Nomer     
; , .  Nomer,( LSL YL;Nomer  .   .) 
;    ,       ,
;    Nomer       Wataa.  
;        / -XH,
;XL-   (EOR TEMP,XL),
;       /,  XL   ,
;         /.
        
	LDI 	ZL,low(mesg*2)	;     . 
	LDI 	ZH,high(mesg*2)	;..   ,    2    .				 
Nachalo2:  	
	LPM		temp,Z+		    ;    ,   Z
		                    ;c    1
;*******************************************************************************************
;*******************************************************************************************
    CPI	temp,0xFF		;0xFF   ,     .
	BREQ	Main            
;*******************************************************************************************
	CP	Command_0,temp		; ,   
	BREQ	Nachalo3        ;  .
    INC Nomer               ; -    ..
    RJMP Nachalo2           ;     mesg.
Nachalo3:                   ;                                 
    MOV YL,Nomer            ;      
		                    ;    -     
						    ;  .                                
    LDI ZL,LOW(Wataa*2);
    LDI ZH,HIGH(Wataa*2)            
    LSL YL                  ;Nomer  .   .
    LDI YH,0                ;         
	                        ;     .    
							; ,        Wataa   
							; /     
                            ;    (   )
                            ; /    /    
                            ;      .

    ADD ZL,YL               ; 2-   ADD  ADC   2- 16- 
    ADC ZH,YH               ;     .
    LPM XL,Z+               ; $xxxx   X   FLASH  Wataa    Z. 
    LPM XH,Z
    TST XH                  
                            
	BREQ ON_ALL             ;    " ".
    CPI XH,0x01             ;    /  01-PORTB,02-PORTD.
				            ;..tn2313   PORTC    Wataa   0x03FF 
							;  0x03       
							;   OFF_ALL-" ".     
                            ;  2-  /     1- .
    BREQ WORK_B             
	CPI XH,0x03             
							 
    BREQ OFF_ALL            ;    " "
    IN TEMP,PORTD           ;  :  D /.
    EOR TEMP,XL             ;        
				            ;     
    OUT PORTD,TEMP          		    	 
    RJMP Main                
WORK_B:  
    IN TEMP,PORTB           ;  B /.
    EOR TEMP,XL
    OUT PORTB,TEMP 				 
    RJMP Main	                                
OFF_ALL:                    ;" "
    CLR R24                 ; 
    OUT PORTB,R24  
    CBI $12,0;
    CBI $12,1;
    CBI $12,2
	CBI $12,4
	CBI $12,6
	RJMP Main		
        						
ON_ALL:                     ; 
	SER R24
	OUT PORTB,R24
	SBI $12,0;
	SBI $12,1;
	SBI $12,2
	SBI $12,4
	SBI $12,6 				            	   
	RJMP Main

; --- Reset_TMR ---
Reset_TMR:	    
    ldi	temp,0b00000011		;   64-011/8-10
    out	TCCR0B,	temp			
    ldi	temp,	Delay_1125us;  (1,125 )
    out	TCNT0,	temp
    ldi	temp,	0b00000010	; 
    out	TIMSK,	temp
    ret

;--- Resync_TMR ---
Resync_TMR:	    
    ldi	temp,Delay_1125us	;  (1,125 )
    out	TCNT0,	temp
    ret

;--- Timer0_Overflow ---
TIM0_OVF:
	ldi	temp,	Delay_1125us;  (1,125 )
	out	TCNT0,	temp
    tst	Delay
    breq	TMR_Exit
    dec	Delay

TMR_Exit:	
    reti

;one -      -  Command_3  Command_2.

one: .db 0x40,0xBF 
	                           
 ;:  Ѩ   "".  Nachalo.
;**************************************************************************************************
; omer       1    2   3     4    5    6    7     8   9   10   11   12   13   14   15   16
;*************************************************************************************************** 
 mesg: .db  0xCF,0x4F,0x8F,0xF7,0x77,0xB7,0xD7,0x57,0x97,0xEF,0xDF,0x5F,0xAA,0xBB,0xCC, 0xFF     
 ;***************************************************************************************************
; 	  1    2    3    4    5    6    7    8    9    0    EQ  "-".                .
;***************************************************************************************************         
; EQ- PortB -> $FF  , PortD ->b0,b1,b2,b4,b6->1  
; " - " - PortB -> $00  , PortD ->b0,b1,b2,b4,b6->0. 
;********************************************************************************************************************
; omer         1      2      3      4      5      6      7      8      9     10     11     12     13      14    15
;********************************************************************************************************************    
 Wataa: .DW  0x0210,0x0102,0x0104,0x0110,0x0120,0x0240,0x0101,0x0108,0x0140,0x0180,0x0000,0x03FF,0x0201,0x0202,0x0204         
;**********************************************************************************************************************      
;       1      2      3      4      5      6      7      8      9      0      EQ    "-"     A      B      C
;**********************************************************************************************************************
; :           1      2      4      5             0      3      6      7     (   0....7  )    
;**********************************************************************************************************************      
; D:    4                                  6                                 (0,1,2,4,6  )  0       1      2
;**********************************************************************************************************************                                                                             

  
;  *** NEC Protocol ***
;
;     _______         _   _   _   _         _   _   _   _
;   _|       |_______| |_| |_| |_| |_ ...  | |_| |_| |_| |_
;
;      9,0ms  4,5ms     0 .. 11              D0 .. D7
;
;
;     "0"                            "1"
;    _   _                         _      _
;   | |_| |_                      | |____| |_
;
;   |___|______ 1,125ms           |______|______ 2,25ms


