
;  MCU freq		4.0 MHz
;  RC protocol		NEC
#include	"tn2313def.inc"
; ---   ---
.def	C		= R18		;
.def	Delay		= R20	;  
.def    temp   =   R21      ;  
.def	Command_0	= R5;	;    
.def	Command_1	= R6;
.def	Command_2	= R7;
.def	Command_3	= R8;
.def	addr = R25			;     PROM

; ---   ---             
.equ    Delay_1125us	=$b6;f=4.0 MHz:TCCR0B=11 8  ($b6+73=$ff)  .
                            ;     1.125/ 
						    ;  1.19-1.20 /,AVRCalk.
							;     Delay_1125us      $B6. 
; ---   ---
.equ	IRR		= 3			;PD3 -  
.equ	LED		= 4			;PD4 - LED (/)VD12.
.equ    SINXRO  = 5         ; VD1.      .   
;==========================================================================
       .cseg
; ---    ---
       .org 0
        rjmp RESET		;  
   	    reti   ;INT0  External Interrupt0 Handler
	    reti   ;INT1 ; External Interrupt1 Handler
	    reti   ;rjmp TIM1_CAPT ; Timer1 Capture Handler
 	    reti   ;rjmp TIM1_COMPA ; Timer1 CompareA Handler
 	    reti   ;rjmp TIM1_OVF ; Timer1 Overflow Handler
 	    rjmp TIM0_OVF ; Timer0 Overflow Handler
 	    reti   ;USART0_RXC ; USART0 RX Complete Handler
   	    reti   ;rjmp USART0_DRE ; USART0,UDR Empty Handler
 	    reti   ;rjmp USART0_TXC ; USART0 TX Complete Handler
 	    reti   ;rjmp ANA_COMP ; Analog Comparator Handler
 	    reti   ;rjmp PCINT ; Pin Change Interrupt
 	    reti   ;rjmp TIMER1_COMPB ; Timer1 Compare B Handler
 	    reti   ;rjmp TIMER0_COMPA ; Timer0 Compare A Handler
 	    reti   ;rjmp TIMER0_COMPB ; Timer0 Compare B Handler
 	    reti   ;rjmp USI_START ; USI Start Handler
	    reti   ;rjmp USI_OVERFLOW ; USI Overflow Handler
	    reti   ;rjmp EE_READY ; EEPROM Ready Handler
 	    reti   ;rjmp WDT_OVERFLOW ; Watchdog Overflow Handler
;============================================================================
; ---  ---
RESET:	
	    cli					; 

	    ldi	temp,$DF
        out	SPL,temp	    ;  

        ldi	temp,0b00000000  
 	    out	DDRB,temp       ;  PortB (0)- 
    	
	    ldi	temp,0b0110000  ;PD3-TSOP1736-,4-LED.PD5-SINXRO.
 	    out	DDRD,temp       ;  PortD (1)-.
		
	    ldi	temp,0b0000000  ;    D
	    out	PORTD,temp      ;PD1-TSOP 1736 .
		
	    rcall	Reset_TMR	; 
	    clr	addr			;     

	    sei					;  
;===========================================================================================			     	;
Main:	sbi	PortD,	SINXRO  ;    !  .

        clr	Command_0		;   
		clr	Command_1
		clr	Command_2
	    clr	Command_3

Main_0:	sbic	PinD,	IRR	; 0 (    )
		rjmp	Main_0
                
        ldi	Delay,	8		; 8   (8 * 1,125 = 9 )
        rcall	Resync_TMR	; 

Main_1: tst	Delay		    ;   
	    breq	Main		;  ,  

        sbis	PinD,	IRR	;  1 - 
        rjmp	Main_1

        cpi	Delay,	2		;  ,   1 - 
        brge	Main
		cbi	PortD,	SINXRO  ;    !
        ldi	Delay,	4		; 4   (4 * 1,125 = 4,5 )
        rcall	Resync_TMR	; 

Main_2:	tst	Delay	        ;   
		breq	Main		;  ,  
        sbic	PinD,	IRR	;  0 - 
        rjmp	Main_2

        cpi	Delay,	2		;  ,   1 - 
        brge	Main

; *** Loop ***
				
		ldi	C,	32			;   -  32 
				
Loop_1: sbic PinD,IRR       ;  0.  
  		rjmp LooP_1	   

  	    ldi	Delay,	1		; 1   (1,125 )
        rcall	Resync_TMR	; 

Main_3:	tst	Delay			; 1
        breq	Main		;   1  ( ) -  
        sbis	PinD,	IRR	;  1 - 
        rjmp	Main_3

Main_4:	tst	Delay			; 0
		breq	Main_S1		; 1  (1,125 ) -> "1"
        sbic	PinD,	IRR	; 1  (1,125 ) -> "0"
        rjmp	Main_4

Main_S0:clc					; "0"   
        rjmp	Main_SB
Main_S1:sec			        ; "1"   

Main_SB:rol	Command_0		;    
       	rol	Command_1		;   
        rol	Command_2
        rol	Command_3

		dec	C				; 
        brne	Loop_1		;  
		cli                 ;      .            
;=============================================================================================
EEWrite1 : 
;  (  )      !
        sbic EECR,EEPE      ;  EEPROM
	    rjmp EEWrite1
 	    out EEAR,addr   
	    out EEDR,Command_3   
	    sbi EECR,EEMPE      ;   
	    sbi EECR,EEPE 
	    inc addr            ;   EEPROM. 
EEWrite2 :
	    sbic EECR,EEPE      ;  EEPROM
	    rjmp EEWrite2
	    out EEAR,addr       ;   
	    out EEDR,Command_2  
	    sbi EECR,EEMPE      ;   
	    sbi EECR,EEPE 
	    inc addr	
EEWrite3 :
   	    sbic EECR,EEPE      ;  EEPROM
	    rjmp EEWrite3
	    out EEAR,addr       ;    
	    out EEDR,Command_1   
	    sbi EECR,EEMPE      ;   
	    sbi EECR,EEPE 
	    inc addr
EEWrite4 :
	    sbic EECR,EEPE      ;  EEPROM
	    rjmp EEWrite4
	    out EEAR,addr       ;   
	    out EEDR,Command_0  
	    sbi EECR,EEMPE      ;   
	    sbi EECR,EEPE 
	    inc addr
;==================================================================	
        sbis	PortD,	LED	; ,   LED
        rjmp	bs_0
   bc_0:cbi	PortD,	LED
        rjmp	sk_0
   bs_0:sbi	PortD,	LED
   sk_0:sei                ; 
 		rjmp	Main
;==================================================================	
; --- Reset_TMR ---
Reset_TMR:	
        ldi	temp,	0b00000011	;   64-011
        out	TCCR0B,	temp			
        ldi	temp,	Delay_1125us;  (1,125 )
        out	TCNT0,	temp
        ldi	temp,	0b00000010	; 
        out	TIMSK,	temp
		ret
; --- Resync_TMR ---
Resync_TMR:
	    ldi	temp,	Delay_1125us;  (1,125 )
        out	TCNT0,	temp
        ret
; --- Timer0_Overflow ---
TIM0_OVF:
		ldi	temp,	Delay_1125us;  (1,125 )
		out	TCNT0,	temp
        tst	Delay
        breq	TMR_Exit
        dec	Delay
TMR_Exit:
        reti

;*** NEC Protocol ***
;
;     _______         _   _   _   _         _   _   _   _
;   _|       |_______| |_| |_| |_| |_ ...  | |_| |_| |_| |_
;
;      9,0ms  4,5ms     0 .. 11              D0 .. D7
;
;
;     "0"                            "1"
;    _   _                         _      _
;   | |_| |_                      | |____| |_
;
;   |___|______ 1,125ms           |______|______ 2,25ms
;
